Index: lib/spatial/mapbuilder/lib/widget/WebServiceForm.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/WebServiceForm.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/WebServiceForm.js	(revision 4307)
@@ -2,11 +2,12 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: WebServiceForm.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
 mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+//mapbuilder.loadScript(baseDir+"/util/dojo/src/uuid/TimeBasedGenerator.js");
 
 /**
  * Widget to display a form for input of parameters to generate a web service 
@@ -26,28 +27,80 @@
 function WebServiceForm(widgetNode, model) {
   WidgetBaseXSL.apply(this,new Array(widgetNode, model));
   this.formElements = new Object();
-
+  // We might have a request stylesheet to fill for a more complex post
+  var requestStylesheet = this.getProperty("mb:requestStylesheet");
+  if (requestStylesheet) {
+    this.requestStylesheet = new XslProcessor(requestStylesheet, model.namespace); 
+  }
+  
+  this.webServiceUrl = this.getProperty("mb:webServiceUrl");
+  
   /**
    * Handles submission of the form (via javascript in an <a> tag)
    */
   this.submitForm = function() {
     this.webServiceForm = document.getElementById(this.formName);
-
-    //create the http GET URL
-    //TBD: handle POST submission
-    //TBD: create filter request
-    var webServiceUrl = this.webServiceForm.action + "?";
-    for (var i=0; i<this.webServiceForm.elements.length; ++i) {
-      var element = this.webServiceForm.elements[i];
-      webServiceUrl += element.name + "=" + element.value + "&";
-      this.formElements[element.name] = element.value;
+    if( this.webServiceForm == null ) { 
+      // get it from a user div instead if present
+      this.webServiceForm = document.getElementById("webServiceForm_form");
     }
-    if (this.debug) alert(webServiceUrl);
-
+    
+    if( this.webServiceForm == null ) {
+        
+      return;
+    }
+    
     var httpPayload = new Object();
-    httpPayload.method = "get";
-    httpPayload.url = webServiceUrl;
-    this.targetModel.newRequest(this.targetModel,httpPayload);
+    httpPayload.method = this.targetModel.method;
+    httpPayload.url = this.webServiceUrl;
+    
+    if (httpPayload.method.toLowerCase() == "get") {
+      httpPayload.url = this.webServiceForm.action + "?";
+      for (var i=0; i<this.webServiceForm.elements.length; ++i) {
+        var element = this.webServiceForm.elements[i];
+        webServiceUrl += element.name + "=" + element.value + "&";
+        this.formElements[element.name] = element.value;
+      }  
+      
+      mbDebugMessage(this, httpPayload.url);
+    
+      this.targetModel.newRequest(this.targetModel,httpPayload);
+    
+    } else { 
+        // a post
+        // put parameters we got in request stylesheet
+      for (var i=0; i<this.webServiceForm.elements.length; ++i) {
+        var element = this.webServiceForm.elements[i];
+        this.formElements[element.name] = element.value;
+      }  
+      
+      this.requestStylesheet.setParameter("resourceName", this.formElements["feature"])
+      this.requestStylesheet.setParameter("fromDateField", this.formElements["fromDateField"])
+      this.requestStylesheet.setParameter("toDateField", this.formElements["toDateField"])
+  
+      // @TODO
+      // we need a new uuid if we wnat to uniquely identify new layers  
+      // var uuid = dojo_uuid_TimeBasedGenerator.generate();
+       
+      var layer = this.requestStylesheet.transformNodeToObject(this.model.doc); 
+      //layer.childNodes[0].setAttribute("id", uuid)
+      if (this.debug) mbDebugMessage(this, "Transformed: "+ (new XMLSerializer()).serializeToString(layer));
+           
+      // extract the GetFeature out
+      this.namespace = "xmlns:wmc='http://www.opengis.net/context' xmlns:ows='http://www.opengis.net/ows' xmlns:ogc='http://www.opengis.net/ogc' xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:xlink='http://www.w3.org/1999/xlink' xmlns:gml='http://www.opengis.net/gml' xmlns:wfs='http://www.opengis.net/wfs'";
+      
+      Sarissa.setXpathNamespaces(layer, this.namespace);
+      var getFeature = layer.selectSingleNode("//wfs:GetFeature")
+      
+      httpPayload.postData = (new XMLSerializer()).serializeToString( getFeature);
+      
+      mbDebugMessage(this, "httpPayload.postData:"+ httpPayload.postData);
+      
+      this.targetModel.wfsFeature = layer.childNodes[0];
+      if (this.debug) mbDebugMessage(this, "wfsFeature = "+ (new XMLSerializer()).serializeToString(this.targetModel.wfsFeature));
+        
+      this.targetModel.newRequest(this.targetModel,httpPayload);
+    }
   }
 
   /**
@@ -80,6 +133,11 @@
    */
   this.postPaint = function(objRef) {
     objRef.webServiceForm = document.getElementById(objRef.formName);
+    if( this.webServiceForm == null ) { 
+      // get it from a user div instead if present
+      this.webServiceForm = document.getElementById("webServiceForm_form");
+    }
+    
     objRef.webServiceForm.parentWidget = objRef;
     objRef.webServiceForm.onkeypress = objRef.handleKeyPress;
     //objRef.WebServiceForm.onsubmit = objRef.submitForm;
@@ -100,6 +158,32 @@
     }
   }
 
+  /**
+    * Setup the listener for AOI changes to be used in filter if necessary
+    */
+  this.setAoiParameters = function(objRef,bbox) {
+    if (objRef.model) {
+      var featureSRS = null;
+      var containerSRS = objRef.model.getSRS();
+     
+      objRef.requestStylesheet.setParameter("bBoxMinX", bbox[0][0] );
+      objRef.requestStylesheet.setParameter("bBoxMinY", bbox[1][1] );
+      objRef.requestStylesheet.setParameter("bBoxMaxX", bbox[1][0] );
+      objRef.requestStylesheet.setParameter("bBoxMaxY", bbox[0][1] );
+      objRef.requestStylesheet.setParameter("srs", containerSRS );
+      objRef.requestStylesheet.setParameter("width", objRef.model.getWindowWidth() );
+      objRef.requestStylesheet.setParameter("height", objRef.model.getWindowHeight() );
+    }
+  }
 
+  this.init = function(objRef) {
+    if (objRef.model) {
+      objRef.model.addListener("aoi", objRef.setAoiParameters, objRef);
+      //TBD: another one for bbox
+    }
+  }
+  
+  this.model.addListener("init", this.init, this);
+
 }
 
Index: lib/spatial/mapbuilder/lib/widget/Save.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Save.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Save.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Save.js 3052 2007-08-01 21:25:21Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -21,39 +21,26 @@
 function Save(widgetNode, model) {
   ButtonBase.apply(this, new Array(widgetNode, model));
 
-  /**
-   * Calls the targetModel's saveModel() method to serialize the model document.
-   * @param objRef      Pointer to this AoiMouseHandler object.
+ /**
+   * Save model control.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} instance of the OL control.
    */
-  this.doSelect = function(selected,objRef) {
-    if (selected) {
-      objRef.targetModel.saveModel(objRef.targetModel);
-    }
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+    
+      type: OpenLayers.Control.TYPE_BUTTON,
+      
+      trigger: function () {
+       		this.map.mbMapPane.targetModel.saveModel(this.map.mbMapPane.targetModel);  
+                 
+            
+       },
+       CLASS_NAME: 'mbControl.Save'
+  });
+  return Control;
   }
 
-  /**
-   * opens a saved model in a popup window
-   * @param objRef Pointer to this SaveModel object.
-   */
-  this.savedModelPopup = function(objRef, fileUrl) {
-    window.open(fileUrl, this.popupWindowName);
-  }
-
-  /**
-   * set a "modelSaved" listener to call the opoup window opener
-   * @param objRef Pointer to this SaveModel object.
-   */
-  this.initReset = function(objRef) {
-    objRef.targetModel.addListener("modelSaved",objRef.savedModelPopup, objRef);
-  }
-
-  //if popupWindowName is specified in config, then add a modelSaved listener 
-  var popupWindowName = widgetNode.selectSingleNode("mb:popupWindowName");
-  if (popupWindowName) {
-    this.popupWindowName = popupWindowName.firstChild.nodeValue;
-    this.model.addListener("init",this.initReset, this);
-  }
-
 }
 
 
Index: lib/spatial/mapbuilder/lib/widget/SelectFromAtomFeed.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectFromAtomFeed.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/SelectFromAtomFeed.js	(revision 4307)
@@ -0,0 +1,32 @@
+/*
+Author:       Cameron Shorter cameronAtshorter.net
+License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
+
+$Id: SelectFromAtomFeed.js 3888 2008-02-27 18:25:45Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * A widget which displays a list of atom elements to select from. The
+ * selected element's URL is loaded as a model, usually a context model.
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+
+function SelectFromAtomFeed(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+
+  /**
+   * Switch to another model (usually a map context).
+   * This function is called from SelectFromAtomFeed.xsl
+   * @param objRef this widget
+   * @modelUrl the URL of the XML we want to switch to.
+   */
+  SelectFromAtomFeed.prototype.switchModel=function(objRef, modelUrl) {
+    config.loadModel( this.targetModel.id, modelUrl );
+  }
+}
Index: lib/spatial/mapbuilder/lib/widget/Loading.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Loading.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Loading.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Loading.js 3702 2007-12-09 23:24:11Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -25,8 +25,11 @@
    * @param objRef Reference to this object.
    */
   this.paint= function(objRef) {
-    while (objRef.node.childNodes.length>0) {
-      objRef.node.removeChild(objRef.node.childNodes[0]);
+    var node = document.getElementById(objRef.htmlTagId);
+    if (node) {
+      while (node.childNodes.length>0) {
+        node.removeChild(node.childNodes[0]);
+      }
     }
   }
   this.model.addListener("refresh",this.paint, this);
Index: lib/spatial/mapbuilder/lib/widget/SelectFeatureType.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectFeatureType.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/SelectFeatureType.js	(revision 4307)
@@ -0,0 +1,18 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: SelectFeatureType.js 2546 2007-01-23 12:07:39Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Presents the list of FeatureTypes from a WFS capabilities doc.
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function SelectFeatureType(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+}
Index: lib/spatial/mapbuilder/lib/widget/Null.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Null.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Null.xsl	(revision 4307)
@@ -1,22 +1,2 @@
-<?xml version="1.0" encoding="UTF-8"?>
-
-<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"> 
-
-<!--
-
-Description: An empty stylesheet for widgets which don't use XSL to render.
-
-Author:      Cameron Shorter cameron ATshorter.net
-
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-
-
-$Id$
-
-$Name$
-
--->
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"/>
Index: lib/spatial/mapbuilder/lib/widget/CatSearchForm.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/CatSearchForm.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/CatSearchForm.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: CatSearchForm.js 3091 2007-08-09 12:21:54Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -18,7 +18,7 @@
  * See widget/NtsForm.xsl for an example. 
  *
  * @constructor
- * @base WidgetBase
+ * @base WidgetBaseXSL
  * @param widgetNode This widget's object node from the configuration document.
  * @param model The model that this widget is a view of.
  */
@@ -161,7 +161,7 @@
           params = "width=280,height=180,scrollbars=0,toolbar=0,location=0,directories=0,status=0,menubar=0,resizable=0";
           break;
         default:
-          alert("unkown RUC type");
+          alert(mbGetMessage("unknownRucType"));
           break;
       }
       RUC_Window = open( baseURL, "RUCWindow", params );
Index: lib/spatial/mapbuilder/lib/widget/SelectFeatureType.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectFeatureType.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/SelectFeatureType.xsl	(revision 4307)
@@ -1,124 +1,3 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-
-
-<!--
-
-Description: presents the list of FeatureTypes from a WFS capabilities doc.
-
-            Links provided to filter and load the selected FeatureType.
-
-Author:      adair
-
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-
-
-$Id$
-
-$Name$
-
--->
-
-
-
-<xsl:stylesheet version="1.0" 
-
-    xmlns:wfs="http://www.opengis.net/wfs"
-
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-
-		xmlns:ogc="http://www.opengis.net/ogc"
-
-		xmlns:gml="http://www.opengis.net/gml"
-
-    xmlns:xlink="http://www.w3.org/1999/xlink">
-
-
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-
-
-  <!-- The coordinates of the DHTML Layer on the HTML page -->
-
-  <xsl:param name="modelId"/>
-
-  <xsl:param name="widgetId"/>
-
-  <xsl:param name="toolId"/>
-
-  
-
-  <!-- template rule matching source root element -->
-
-  <xsl:template match="/wfs:WFS_Capabilities">
-
-    <table>
-
-      <tr>
-
-        <th>
-
-          Feature types from: <xsl:value-of select="wfs:Service/wfs:Title"/>
-
-        </th>
-
-        <td colspan="2">
-
-          <a href="javascript:config.paintWidget(config.objects.wfsServerList)">Back to list</a>
-
-        </td>
-
-      </tr>
-
-      <xsl:apply-templates select="wfs:FeatureTypeList/wfs:FeatureType"/>
-
-    </table>
-
-  </xsl:template>
-
-
-
-  <!-- template rule matching source root element -->
-
-  <xsl:template match="wfs:FeatureType">
-
-    <xsl:variable name="name"><xsl:value-of select="wfs:Name"/></xsl:variable>
-
-    <xsl:variable name="title"><xsl:value-of select="wfs:Title"/></xsl:variable>
-
-    <xsl:variable name="id"><xsl:value-of select="@id"/></xsl:variable>
-
-    <tr>
-
-      <td>
-
-        <xsl:value-of select="$title"/> (<xsl:value-of select="$name"/>) <xsl:value-of select="wfs:SRS"/>
-
-      </td>
-
-      <td>
-
-        <a href="javascript:config.objects.{$modelId}.setParam('wfs_GetFeature','{$name}')">load</a>
-
-      </td>
-
-      <td>
-
-        <a href="javascript:config.objects.{$modelId}.setParam('wfs_DescribeFeatureType','{$name}')">filter</a>
-
-      </td>
-
-    </tr>
-
-  </xsl:template>
-
-
-
-  <xsl:template match="text()|@*"/>
-
-
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:wfs="http://www.opengis.net/wfs" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ogc="http://www.opengis.net/ogc" xmlns:gml="http://www.opengis.net/gml" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:param name="toolId"/><xsl:template match="/wfs:WFS_Capabilities"><table><tr><th colspan="3">
+          Feature types from: <xsl:value-of select="wfs:Service/wfs:Title"/></th></tr><xsl:apply-templates select="wfs:FeatureTypeList/wfs:FeatureType"/></table></xsl:template><xsl:template match="wfs:FeatureType"><xsl:variable name="name"><xsl:value-of select="wfs:Name"/></xsl:variable><xsl:variable name="title"><xsl:value-of select="wfs:Title"/></xsl:variable><xsl:variable name="id"><xsl:value-of select="@id"/></xsl:variable><tr><td><xsl:value-of select="$title"/> (<xsl:value-of select="$name"/>) <xsl:value-of select="wfs:SRS"/></td><td><a href="javascript:config.objects.{$modelId}.setParam('wfs_GetFeature','{$name}')">load</a></td><td><a href="javascript:config.objects.{$modelId}.setParam('wfs_DescribeFeatureType','{$name}')">filter</a></td><td><a href="javascript:alert('not yet implemented')">style</a></td></tr></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/ZoomOut.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/ZoomOut.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/ZoomOut.js	(revision 4307)
@@ -1,49 +1,58 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: ZoomOut.js 3894 2008-02-29 18:37:09Z ahocevar $
 */
 
 // Ensure this object's dependancies are loaded.
 mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
 
 /**
- * When this button is selected, click on the map to zoom out centered at the click.
- * @constructor
+ * Zoom Out button.
  * @base ButtonBase
- * @author Mike Adair mike.adairATccrs.nrcan.gc.ca
- * @param widgetNode The widget node from the Config XML file.
- * @param model  The model for this widget
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @param widgetNode      The tool node from the Config XML file.
+ * @param model  The ButtonBar widget.
  */
 function ZoomOut(widgetNode, model) {
-  // Extend ButtonBase
-  ButtonBase.apply(this, new Array(widgetNode, model));
+   ButtonBase.apply(this, new Array(widgetNode, model));
 
-  this.zoomBy = 4;//TBD: get this from config
+  this.cursor = 'crosshair';
 
   /**
-   * Calls the centerAt method of the context doc to zoom out, recentering at 
-   * the mouse event coordinates.
-   * TBD: set the zoomBy property as a button property in conifg
-   * @param objRef      Pointer to this AoiMouseHandler object.
-   * @param targetNode  The node for the enclosing HTML tag for this widget.
+   * Interactive ZoomOut control.
+   * @param objRef reference to this object.
+   * @return {OpenLayers.Control} class of the OL control.
    */
-  this.doAction = function(objRef,targetNode) {
-    if (!objRef.enabled) return;
-    var bbox = objRef.targetModel.getParam("aoi");
-    var extent = objRef.targetModel.extent;
-    var newRes = extent.res[0]*objRef.zoomBy;
-    extent.centerAt(bbox[0], newRes);
-  }
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class( OpenLayers.Control, {
+      CLASS_NAME: 'mbControl.ZoomOut',
+      type: OpenLayers.Control.TYPE_TOOL,
 
-  /**
-   * Register for mouseUp events.
-   * @param objRef  Pointer to this object.
-   */
-  this.setMouseListener = function(objRef) {
-    if (objRef.mouseHandler) {
-      objRef.mouseHandler.model.addListener('mouseup',objRef.doAction,objRef);
-    }
+      draw: function() {
+        this.handler = new OpenLayers.Handler.Box( this,
+          {done: this.zoomBox}, {keyMask: this.keyMask} );
+      },
+
+      zoomBox: function (position) {
+        if (position instanceof OpenLayers.Bounds) {
+          var minXY = new OpenLayers.Pixel(position.left, position.bottom);
+          var maxXY = new OpenLayers.Pixel(position.right, position.top);
+          var bounds = new OpenLayers.Bounds(minXY.x, minXY.y,
+            maxXY.x, maxXY.y);
+          var mapSize = (this.map.getSize().w+this.map.getSize().h)/2;
+          var boxSize = (Math.abs(bounds.getWidth())+Math.abs(bounds.getHeight()))/2;
+          var newScale = this.map.getScale()*(mapSize/boxSize);
+          this.map.setCenter(bounds.getCenterLonLat());
+          this.map.zoomToScale(newScale);
+        } else { // it's a pixel
+          this.map.setCenter(this.map.getLonLatFromPixel(position),
+            parseInt(this.map.getZoom() - 1));
+        }
+      }
+    });
+    return Control;
   }
-  this.model.addListener( "loadModel", this.setMouseListener, this );
+}
 
-}
+
Index: lib/spatial/mapbuilder/lib/widget/Reset.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/Reset.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/Reset.js	(revision 4307)
@@ -1,56 +1,27 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: Reset.js 2956 2007-07-09 12:17:52Z steven $
 */
 
 // Ensure this object's dependancies are loaded.
 mapbuilder.loadScript(baseDir+"/widget/ButtonBase.js");
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
 
 /**
- * When this button is pressed the map will reload with it's original extent
+ * Reset button - resets the map to full extent.
  * @constructor
  * @base ButtonBase
- * @author Mike Adair mike.adairATccrs.nrcan.gc.ca
- * @param widgetNode      The widget node from the Config XML file.
- * @param model  The model for this widget
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @param widgetNode The widget node from the Config XML file.
+ * @param model The model for this widget
  */
 function Reset(widgetNode, model) {
-  ButtonBase.apply(this, new Array(widgetNode, model));
 
-  // override default cursor by user
-  // cursor can be changed by spefying a new cursor in config file
-  this.cursor = "default"; 
-
-  /**
-   * Store a copy of the original extent locally as a loadModel event listener.
-   * @param objRef Pointer to this object.
-   */
-  this.initExtent = function(objRef) {
-    objRef.originalExtent = new Extent( objRef.targetModel );   
-    objRef.originalExtent.init( objRef.originalExtent );
-    objRef.originalExtent.setResolution( new Array(objRef.targetModel.getWindowWidth(), objRef.targetModel.getWindowHeight()) );
+  this.createControl = function() {
+  	return OpenLayers.Control.ZoomToMaxExtent;
   }
-
-  /**
-   * Set the loadModel listener in response to init event
-   * @param objRef Pointer to this object.
-   */
-  this.initReset = function(objRef) {
-    objRef.targetModel.addListener("loadModel",objRef.initExtent, objRef);
-  }
-  this.model.addListener("init",this.initReset, this);
-
-
-  /**
-   * Calls the reset() method of the context doc to reload at with the original extent
-   * @param objRef      Pointer to this AoiMouseHandler object.
-   */
-  this.doSelect = function(selected,objRef) {
-    if (selected){
-      var originalExtent = objRef.originalExtent;
-      objRef.targetModel.extent.centerAt( originalExtent.getCenter(), originalExtent.res[0] );
-    }
-  }
+  
+  // Extend ButtonBase
+  ButtonBase.apply(this, new Array(widgetNode, model));
 }
 
-
